#include "Arc.h"
#include <stdlib.h>
#include <iomanip> // to use the setprecision manipulator

/*********************************************
	Constructores
 *********************************************/

Arc::Arc() 
{
}

Arc::Arc(istream & infile) 
{
  int i,tempx,tempy;	
  infile >> sub_type;
  infile >> line_style;
  infile >> line_thickness;
  infile >> pen_color;
  infile >> fill_color;
  infile >> depth;
  infile >> pen_style;
  infile >> area_fill;
  infile >> style_val;
  infile >> cap_style;
  infile >> direction;
  infile >> forward_arrow;
  infile >> backward_arrow;
  infile >> center_x;
  infile >> center_y;
  X.resize(3);				// x1, x2, x3 
  Y.resize(3);				// y1, y2, y3
  for(i=0;i<3;i++){
	 infile >> X[i];
	 infile >> Y[i];
  }
  if (forward_arrow || backward_arrow){
	infile >> arrow_type;	
	infile >> arrow_style;
	infile >> arrow_thickness;
	infile >> arrow_width;
	infile >> arrow_height;
  }
}
/*********************************************
	Operaciones

 *********************************************/

void Arc::write(void)
{
  cout << object_code << ' ' << sub_type 
       << ' ' << line_style << ' ' << line_thickness<< ' ' ;
  cout << pen_color << ' ' << fill_color
       << ' ' << depth << ' ' << pen_style<< ' ';
  cout << area_fill << ' ' << style_val << ' ' << cap_style
       << ' ' << direction << ' ' << forward_arrow<< ' ' ;
  cout << backward_arrow << ' ' << center_x  << ' ' << center_y
       << ' ' << X[0] << ' ' << Y[0] << ' ' << X[1] << ' ' << Y[1] << ' ' ;
  cout << X[2] << ' ' << Y[2] <<  ' ';
  if (forward_arrow || backward_arrow){
	cout << arrow_type <<  ' ';	
	cout << arrow_style <<  ' ';
	cout << arrow_thickness <<  ' ' ;
	cout << arrow_width <<  ' ' ;
	cout << arrow_height;
  }
  cout << '\n';
}

//-----------------------------------------------------

void Arc::mag(int x, int y, double f)
{
  line_thickness= int(line_thickness*f);
  for(int i=0;i<3;i++){
	X[i] = x + int((X[i]-x)*f);
	Y[i] = y + int((Y[i]-y)*f);
  }
  center_x = x+int((center_x-x)*f);
  center_y = y+int((center_y-y)*f);
  arrow_thickness = arrow_thickness*f;
  arrow_width = arrow_width*f;
  arrow_height = arrow_height*f;
    
}

//-----------------------------------------------------

void Arc::trans(int x, int y)
{
  for(int i=0;i<3;i++){
	X[i]+= x;
	Y[i]+= y;
  }
  center_x+= x;
  center_y+= y;
}

//-----------------------------------------------------

void Arc::rot(int x, int y, char Sentido)
{
	int A,B;
	vector<float> Xr,Yr;
	int transx,transy;
	Xr.resize(3);
	Yr.resize(3);
	//parametros auxiliares para la rotacin
	if(Sentido == 'F'){
		A = -1;
		B =	 1; 
	}
	if(Sentido == 'C'){
		A = 1;
		B = -1;
	}

	S_swap(X,Y);			// Cambiando valores de x por y 


	for(int i=0;i<3;i++){								//rotando la figura respecto a su origen
		X[i] = int(center_x - A*(center_y - X[i]));
		Y[i] = int(center_y - B*(center_x - Y[i]));
	}   
    
	//S_swap(center_x,center_y);			// Cambiando valores de x por y
	//S_swap(X,Y);

	//	center_x = x + A*(y - center_x);
	//	center_x = y + B*(x - center_x);

  
	transx =B*int(y - center_y);
	transy =A*int(x - center_x);

    trans(transx,transy);

}

