#ifndef ARC_H
#define ARC_H

#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include "Forma.h"

#define ARC_OBJECT_CODE 5 

class Arc:public Forma
{
public:
  Arc();
  Arc(istream & inFile);
  
  virtual void write(void);
  virtual void mag(int x, int y, double f);
  virtual void trans(int x, int y);
  virtual void rot(int x, int y, char Sentido);

  static const int object_code = ARC_OBJECT_CODE;  //(always 5)

private:
	int	    sub_type;    	    /*(1: open ended arc
					             2: pie-wedge (closed) )*/
	int	    line_style;		     //(enumeration type)
	int	    line_thickness;		 //(1/80 inch)
	int	    pen_color;		     //(enumeration type, pen color)
	int	    fill_color;		     //(enumeration type, fill color)
	int	    depth;			     //(enumeration type)
	int	    pen_style;		     //(pen style, not used)
	int	    area_fill;			 //(enumeration type, -1 = no fill)
	float	style_val;			 //(1/80 inch)
	int	    cap_style;			 //(enumeration type)
	int	    direction;			 //(0: clockwise, 1: counterclockwise)
	int	    forward_arrow;		 //(0: no forward arrow, 1: on)
	int	    backward_arrow;		 //(0: no forward arrow, 1: on)
	float	center_x;			 //(x center of the arc)
	float   center_y;			 //(y center of the arc)
	vector<int> X;               // vector of points 1,2,3 x coordinates
	vector<int> Y;               // vector of points 1,2,3 y coordinates

    //Forward arrow line (Optional; absent if forward_arrow is 0):
	//type	name			(brief description)
	//----	----			-------------------
	
	int	    arrow_type;			 //(enumeration type)
	int	    arrow_style;		 //(enumeration type)
	float	arrow_thickness;	 //(1/80 inch)
	float 	arrow_width;		 //(Fig units)
	float	arrow_height;		 //(Fig units)

};


#endif
