#include "Ellipse.h"
#include <iomanip> // to use the setprecision manipulator

/*********************************************
	Constructores
 *********************************************/

Ellipse::Ellipse() 
{
}

Ellipse::Ellipse(ifstream & infile) 
{
  infile >> sub_type;
  infile >> line_style;
  infile >> thickness;
  infile >> pen_color;
  infile >> fill_color;
  infile >> depth;
  infile >> pen_style;
  infile >> area_fill;
  infile >> style_val;
  infile >> direction;
  infile >> angle;
  infile >> center_x;
  infile >> center_y;
  infile >> radius_x;
  infile >> radius_y;
  infile >> start_x;
  infile >> start_y;
  infile >> end_x;
  infile >> end_y;
}

/*********************************************
	Operaciones
 *********************************************/

void Ellipse::write(void)
{
  cout << object_code << ' ' << sub_type 
       << ' ' << line_style << ' ' << thickness
       << ' ' << pen_color << ' ' << fill_color << ' ' ;
  cout << depth << ' ' << pen_style
       << ' ' << area_fill << ' ' << style_val << ' ' << direction
       << ' ' << angle << ' ' << center_x << ' ' << center_y 
       << ' ' << radius_x << ' ' << radius_y 
       << ' ' << start_x << ' ' << start_y 
       << ' ' << end_x << ' ' << end_y << '\n';

}

//-----------------------------------------------------

void Ellipse::mag(int x, int y, double f)
{
  thickness= int(thickness*f);
  center_x = x+int((center_x-x)*f);
  center_y = y+int((center_y-y)*f);
  radius_x= int(radius_x*f);
  radius_y= int(radius_y*f);
  start_x = x+int((start_x-x)*f);
  start_y = y+int((start_y-y)*f);
  end_x = x+int((end_x-x)*f);
  end_y = y+int((end_y-y)*f);
}

//-----------------------------------------------------

void Ellipse::trans(int x, int y)
{
  center_x += x;
  center_y += y;
  start_x += x;
  start_y += y;
  end_x += x;
  end_y += y;
}

//-----------------------------------------------------

void Ellipse::rot(int x, int y,char Sentido)
{
 	int A,B;					//parametros auxiliares para la rotacin
	if(Sentido == 'F'){
		A = -1;
        B =  1;
	}
    if(Sentido == 'C'){
        A = 1;
		B = -1;	
	}
   
 
	S_swap(start_x,start_y);	// Cambiando valores de x por y
	S_swap(end_x,end_y);
    S_swap(center_x,center_y);
	S_swap(radius_x,radius_y);
	start_x = x - A*(y - start_x);
	start_y = y - B*(x - start_y);
	end_x = x - A*(y - end_x);
	end_y = y - B*(x - end_y);
	center_x = x - A*(y - center_x);
	center_y = y - B*(x - center_y);
}

