#include "Polyline.h"
#include <iomanip> // to use the setprecision manipulator


/*********************************************
	Constructores
 *********************************************/

Polyline::Polyline() 
{
}

Polyline::Polyline(ifstream & infile) 
{
  infile >> sub_type;
  infile >> line_style;
  infile >> thickness;
  infile >> pen_color;
  infile >> fill_color;
  infile >> depth;
  infile >> pen_style;
  infile >> area_fill;
  infile >> style_val;
  infile >> join_style;
  infile >> cap_style;
  infile >> radius;
  infile >> forward_arrow;
  infile >> backward_arrow;
  infile >> npoints;
  Xcoord.resize(npoints);		//Coordenadas X de los puntos
  Ycoord.resize(npoints);		//Coordenadas Y de los puntos

  for(int i=0;i<npoints;i++){
	  infile >> Xcoord[i];
	  infile >> Ycoord[i];
  }

}

/*********************************************
	Operaciones
 *********************************************/

void Polyline::write(void)
{
  cout << object_code << ' ' << sub_type 
       << ' ' << line_style << ' ' << thickness
       << ' ' << pen_color << ' ' << fill_color
       << ' ' << depth << ' ' << pen_style
       << ' ' << area_fill << ' ' << style_val << ' ' << join_style
       << ' ' << cap_style << ' ' << radius << ' ' << forward_arrow
       << ' ' << backward_arrow << ' ' << npoints << '\n';
 
	for(int i=0;i<npoints;i++){
       	cout  << Xcoord[i] << ' ';
        cout  << Ycoord[i] << ' ';
	}
	cout <<'\n';
}

//-----------------------------------------------------

void Polyline::mag(int x, int y, double f)
{
  thickness= int(thickness*f);
  for(int i=0;i<npoints;i++){
	Xcoord[i] = x + int((Xcoord[i]-x)*f);
	Ycoord[i] = y + int((Ycoord[i]-y)*f);
  }
  radius= int(radius*f);
    
}

//-----------------------------------------------------

void Polyline::trans(int x, int y)
{
  for(int i=0;i<npoints; i++){
	Xcoord[i] += x;
	Ycoord[i] += y;
  }
}

//-----------------------------------------------------

void Polyline::rot(int x, int y, char Sentido)
{
	int A,B;						//parametros auxiliares para la rotacin
	if(Sentido == 'F'){
		A = -1;
		B =	 1; 
	}
	if(Sentido == 'C'){
		A = 1;
		B = -1;
	}

	S_swap(Xcoord,Ycoord);			// Cambiando valores de x por y
	
	for(int i=0;i<npoints;i++){
		Xcoord[i] = x - A*(y - Xcoord[i]);
		Ycoord[i] = y - B*(x - Ycoord[i]);
	}
}

