#ifndef POLYLINE_H
#define POLYLINE_H

#include <iostream>
#include <fstream>
#include "Forma.h"
#include <vector>

#define POLYLINE_OBJECT_CODE 2

class Polyline:public Forma
{
public:
  Polyline();
  Polyline(ifstream & inFile);
  
  virtual void write(void);
  virtual void mag(int x, int y, double f);
  virtual void trans(int x, int y);
  virtual void rot(int x, int y, char Sentido);

  static const int object_code=POLYLINE_OBJECT_CODE;//	(always 2)

private:
    int	    sub_type ;		/*(1: polyline
					     2: box
					     3: polygon
					     4: arc-box)
					     5: imported-picture bounding-box)*/
	int	    line_style;		//(enumeration type)
	int	    thickness;		//(1/80 inch)
	int	    pen_color;		//(enumeration type, pen color)
	int	    fill_color;		//(enumeration type, fill color)
	int	    depth;			//(enumeration type)
	int	    pen_style;		//(pen style, not used)
	int	    area_fill;		//(enumeration type, -1 = no fill)
	float	style_val;		//(1/80 inch)
	int	    join_style;		//(enumeration type)
	int	    cap_style;		//(enumeration type, only used for POLYLINE)
	int	    radius;			//(1/80 inch, radius of arc-boxes)
	int	    forward_arrow;		//(0: off, 1: on)
	int	    backward_arrow;		//(0: off, 1: on)
	int	    npoints;			//(number of points in line)
	vector<int> Xcoord;         // x coordinates of points
	vector<int> Ycoord;         // y coordinates of points
};


#endif
